------------------------
----Arena Calculator----
----    by Toppe    ----
------------------------


function ACalc_ChatCommand(cmd)
   ACalc_ShowHide();
end


SlashCmdList["ACALC"] = ACalc_ChatCommand;
SLASH_ACALC1 = "/acalc";
SLASH_ACALC2 = "/arenacalc";
SLASH_ACALC3 = "/arenacalculator";



BINDING_HEADER_ACALC = "Arena Calculator Bindings";
BINDING_NAME_TOGGLEACALC = "Toggle ACalc Window";



function ACalc_ShowHide()
   if ACalcFrame:IsShown() then
      ACalcFrame:Hide();
   else
      UIFrameFadeIn(ACalcFrame, 0.2, 0, 1);
      ACalcFrame:Show();
   end
end



-------------------------------------------
------- RATING TO POINTS CALCULATOR -------
-------------------------------------------


function ACalc_FrameCalc1()
   local ACalc_CalcNumber1=ACalcFrameBox1EditBox:GetNumber();
   local ACalc_FrameCalcAnswer1=0;
   local ACalc_FrameCalcAnswer2=0;
   local ACalc_FrameCalcAnswer3=0;

   if ACalc_CalcNumber1>1500 then
      ACalc_FrameCalcAnswer1=(1426.79/(1 + 918.836 * math.exp(-0.00386405*ACalc_CalcNumber1)));
      ACalc_FrameCalcAnswer2=0.8*ACalc_FrameCalcAnswer1;
      ACalc_FrameCalcAnswer3=0.7*ACalc_FrameCalcAnswer1;
   elseif ACalc_CalcNumber1<1501 then
      ACalc_FrameCalcAnswer1=0.38*ACalc_CalcNumber1-194;
      ACalc_FrameCalcAnswer2=0.8*ACalc_FrameCalcAnswer1;
      ACalc_FrameCalcAnswer3=0.7*ACalc_FrameCalcAnswer1;
   end

   if ACalc_FrameCalcAnswer1<0 then
      ACalc_FrameCalcAnswer1=0;
   end
   if ACalc_FrameCalcAnswer2<0 then
      ACalc_FrameCalcAnswer2=0;
   end
   if ACalc_FrameCalcAnswer3<0 then
      ACalc_FrameCalcAnswer3=0;
   end

   ACalcFrameTextAnswer1:SetText("|cAAFFD1002v2:|r "..math.floor(ACalc_FrameCalcAnswer3+.5).."|n".."|cAAFFD1003v3:|r "..math.floor(ACalc_FrameCalcAnswer2+.5).."|n".."|cAAFFD1005v5:|r "..math.floor(ACalc_FrameCalcAnswer1+.5));
end



-------------------------------------------
------- POINTS TO RATING CALCULATOR -------
-------------------------------------------


function ACalc_FrameCalc2()
   local ACalc_CalcNumber2=ACalcFrameBox2EditBox2:GetNumber();
   local ACalc_Answer1=ACalc_CalcNumber2/0.7;
   local ACalc_Answer2=ACalc_CalcNumber2/0.8;
   local ACalc_Answer3=ACalc_CalcNumber2;

   if ACalc_Answer1>263 and ACalc_Answer1<1427 then
      ACalc_Answer1=math.floor((math.log((1426.79/ACalc_Answer1 - 1) / 918.836) / -.00386405)+.5);
   elseif ACalc_Answer1<264 then
      ACalc_Answer1=math.floor(((ACalc_Answer1 + 194) / .38)+.5);
   else
      ACalc_Answer1="N/A";
   end

   if ACalc_Answer2>301 and ACalc_Answer2<1427 then
      ACalc_Answer2=math.floor((math.log((1426.79/ACalc_Answer2 - 1) / 918.836) / -.00386405)+.5);
   elseif ACalc_Answer2<302 then
      ACalc_Answer2=math.floor(((ACalc_Answer2 + 194) / .38)+.5);
   else
      ACalc_Answer2="N/A";
   end

   if ACalc_Answer3>376 and ACalc_Answer3<1427 then
      ACalc_Answer3=math.floor((math.log((1426.79/ACalc_Answer3 - 1) / 918.836) / -.00386405)+.5);
   elseif ACalc_Answer3<377 then
      ACalc_Answer3=math.floor(((ACalc_Answer3 + 194) / .38)+.5);
   else
      ACalc_Answer3="N/A";
   end


   ACalcFrameTextAnswer2:SetText("|cAAFFD1002v2:|r "..ACalc_Answer1.."|n".."|cAAFFD1003v3:|r "..ACalc_Answer2.."|n".."|cAAFFD1005v5:|r "..ACalc_Answer3);
end




------------------------------------
-------- START MAIN FUNCTION -------
------------------------------------

local ACalc_temp1=0;
local ACalc_temp2=0;
local ACalc_temp3=0;



function ACalc_Main()

   local ACalc_ArenaTeam1=ACalc_Rating(1);
   local ACalc_ArenaTeam2=ACalc_Rating(2);
   local ACalc_ArenaTeam3=ACalc_Rating(3);

   local ACalc_max=0;
   local ACalc_APWidth=85;

   if ACalc_Size(1)==2 then
      ACalc_temp1=math.floor(ACalc_Calculate(1)+.5)
      ACalc_ArenaTeam1=ACalc_Rating(1);
   elseif ACalc_Size(1)==3 then
      ACalc_temp2=math.floor(ACalc_Calculate(1)+.5);
      ACalc_ArenaTeam2=ACalc_Rating(1);
   elseif ACalc_Size(1)==5 then
      ACalc_temp3=math.floor(ACalc_Calculate(1)+.5);
      ACalc_ArenaTeam3=ACalc_Rating(1);
   end

   if ACalc_Size(2)==2 then
      ACalc_temp1=math.floor(ACalc_Calculate(2)+.5);
      ACalc_ArenaTeam1=ACalc_Rating(2);
   elseif ACalc_Size(2)==3 then
      ACalc_temp2=math.floor(ACalc_Calculate(2)+.5);
      ACalc_ArenaTeam2=ACalc_Rating(2);
   elseif ACalc_Size(2)==5 then
      ACalc_temp3=math.floor(ACalc_Calculate(2)+.5);
      ACalc_ArenaTeam3=ACalc_Rating(2);
   end

   if ACalc_Size(3)==2 then
      ACalc_temp1=math.floor(ACalc_Calculate(3)+.5);
      ACalc_ArenaTeam1=ACalc_Rating(3);
   elseif ACalc_Size(3)==3 then
      ACalc_temp2=math.floor(ACalc_Calculate(3)+.5);
      ACalc_ArenaTeam2=ACalc_Rating(3);
   elseif ACalc_Size(3)==5 then
      ACalc_temp3=math.floor(ACalc_Calculate(3)+.5);
      ACalc_ArenaTeam3=ACalc_Rating(3);
   end



   PVPTeam1DataRatingLabel:ClearAllPoints();
   PVPTeam1DataRatingLabel:SetPoint("RIGHT",PVPTeam1DataName,"RIGHT",5,0);
   if ACalc_temp1>0 then
      PVPTeam1DataRating:SetText(ACalc_ArenaTeam1.." ("..ACalc_temp1..")");
   end
   PVPTeam1DataRating:SetJustifyH("CENTER");
   PVPTeam1DataRating:SetWidth(70);
	
   PVPTeam2DataRatingLabel:ClearAllPoints();
   PVPTeam2DataRatingLabel:SetPoint("RIGHT",PVPTeam2DataName,"RIGHT",5,0);
   if ACalc_temp2>0 then
      PVPTeam2DataRating:SetText(ACalc_ArenaTeam2.." ("..ACalc_temp2..")");
   end
   PVPTeam2DataRating:SetJustifyH("CENTER");
   PVPTeam2DataRating:SetWidth(70);
	
   PVPTeam3DataRatingLabel:ClearAllPoints();
   PVPTeam3DataRatingLabel:SetPoint("RIGHT",PVPTeam3DataName,"RIGHT",5,0);
   if ACalc_temp3>0 then
      PVPTeam3DataRating:SetText(ACalc_ArenaTeam3.." ("..ACalc_temp3..")");
   end
   PVPTeam3DataRating:SetJustifyH("CENTER");
   PVPTeam3DataRating:SetWidth(70);


   ACalc_max=math.max(ACalc_temp1, ACalc_temp2, ACalc_temp3);

   ACalc_max=ACalc_max+GetArenaCurrency();
   ACalc_max=(GetArenaCurrency().." ("..ACalc_max..")");

   if #ACalc_max<10 then
      ACP_APWidth=65;
   elseif #ACalc_max<11 then
      ACP_APWidth=75;
   elseif #ACalc_max<12 then
      ACP_APWidth=85;
   end


   PVPFrameArenaPoints:SetText(ACalc_max);
   PVPFrameArenaPoints:SetPoint("LEFT", PVPFrameArenaLabel, "RIGHT", 4, 0);
   PVPFrameArenaPoints:SetJustifyH("CENTER");
   PVPFrameArenaPoints:SetWidth(ACP_APWidth);

end


---------------------------------------------
------- UPDATE WHILE SHOWING PVPFRAME -------
---------------------------------------------


--PVPFrame:SetScript("OnUpdate", function() ACalcUpdate(arg1) end)

--function ACalcUpdate(elapsed)
--   ACalc_Main();
--end


function ACalc_OnLoad()
   local oldPVPFrame_Update=PVPFrame_Update
   function newPVPFrame_Update() 
      oldPVPFrame_Update()
      ACalc_Main()
   end
   PVPFrame_Update=newPVPFrame_Update

   local oldPVPFrameToggleButton_OnClick=PVPFrameToggleButton_OnClick
   function newPVPFrameToggleButton_OnClick() 
      oldPVPFrameToggleButton_OnClick()
      ACalc_Main()
   end
   PVPFrameToggleButton_OnClick=newPVPFrameToggleButton_OnClick
end



-----------------------------------------
------- ARENA POINTS CALCULATIONS -------
-----------------------------------------

function ACalc_Calculate(n)
   local points=0;
   local teamName, teamSize, teamRating, teamPlayed, teamWins, playerPlayed, teamRank  = GetArenaTeam(n);
   if teamRating>1500 then 
      points=(1426.79/(1+918.836*math.exp(-0.00386405*teamRating)));
      if teamSize==2 then
         points=0.7*points;
      elseif teamSize==3 then
         points=0.8*points;
      end
   elseif teamRating<1501 then
      points=0.38*teamRating-194;
      if points<0 then 
         points=0;
      end
      if teamSize==2 then
         points=0.7*points;
      elseif teamSize==3 then
         points=0.8*points;
      end
   end
   return points;
end



-------------------------------------
------- GET RATINGS AND SIZES -------
-------------------------------------

function ACalc_Rating(n)
	local teamName, teamSize, teamRating, teamPlayed, teamWins, playerPlayed, teamRank  = GetArenaTeam(n);
	return teamRating;
end


function ACalc_Size(n)
	local teamName, teamSize, teamRating, teamPlayed, teamWins, playerPlayed, teamRank  = GetArenaTeam(n);
	return teamSize;
end